%globabl variables
Tt=6; %length of evidence

nEmotions = 7; 
%1:agreement
%2:disagreement
%3:thinking
%4:comprehending
%5:concentrating
%6:unsure
%7:interested
nActive_emotions=1; 
Active_emotions =[4]; 

%loads the HMM parameters 
load ('hmms_params', 'disp_prior', 'disp_transmat', 'disp_obsmat');
%load the emotion DBN engines 
%load ('emotion_engines', 'prior', 'obsmat', 'transmat', 'engine'); 

nDisplays = 9; %no. of displays supported by the DBN
%1:nod 
%2:shake
%3:tilt
%4:turn
%5:smile
%6:puckerer
%7:raise
%8:mouth open
%9:teeth
Parent_nActive_disp=8; 
Parent_Active_disp = [1 2 4 5 6 7 8 9]; 

nActive_disp=6; 
Actives=zeros(nActive_disp+1,nActive_disp); 

Actives(1,:)=[1 2 3 4 6 7];
Actives(2,:)=[1 2 3 4 6 8];
Actives(3,:)=[1 2 3 4 7 8];
Actives(4,:)=[1 2 3 6 7 8];
Actives(5,:)=[1 2 4 6 7 8];
Actives(6,:)=[1 3 4 6 7 8];
Actives(7,:)=[2 3 4 6 7 8];
       
for x=1:nActive_disp+1
    
    [prior, obsmat, transmat, engine] = create_emotion_engines (nEmotions, nDisplays, nActive_disp, Actives(x,:));
    seqname='_'; 
    seqname=strcat(seqname, int2str(nActive_disp));
    seqname=strcat(seqname, '_'); 
    for g=1:nActive_disp
        seqname= strcat(seqname, int2str(Actives(x,g)));  
    end
    seqname=strcat(seqname, '.csv'); 
    %--------------------------------------------------------------------------
    %Entering evidence into the DBN, and infering the emotions
    %--------------------------------------------------
    for a=1:nActive_emotions
      switch Active_emotions(a)
        case 1
            test_agreement(engine, disp_prior, disp_transmat, disp_obsmat, nActive_disp, Actives(x,:), Tt, nEmotions, seqname);
        case 2
            test_disagreement(engine, disp_prior, disp_transmat, disp_obsmat, nActive_disp, Actives(x,:), Tt, nEmotions, seqname); 
        case 3
            test_thinking(engine, disp_prior, disp_transmat, disp_obsmat, nActive_disp, Actives(x,:), Tt, nEmotions, seqname);
        case 4
            test_comprehending(engine, disp_prior, disp_transmat, disp_obsmat, nActive_disp, Actives(x,:), Tt, nEmotions, seqname); 
        case 5
            test_concentrating(engine, disp_prior, disp_transmat, disp_obsmat, nActive_disp, Actives(x,:), Tt, nEmotions, seqname); 
        case 6
            test_unsure(engine, disp_prior, disp_transmat, disp_obsmat, nActive_disp, Actives(x,:), Tt, nEmotions, seqname); 
        case 7
            test_interested(engine, disp_prior, disp_transmat, disp_obsmat, nActive_disp, Actives(x,:), Tt, nEmotions, seqname);  
      end
    end

end