function [prior, obsmat, transmat, engine] = create_emotion_engines (nEmotions, nDisplays, optStructSize, optStruct);
%create_emotion_engines (nEmotions, nDisplays, nActive_disp, Active_disp);

%load the emotion and non_emotion MLEs for each of the emotions
load ('emotion_nonemotion_mle', 'emotion_mle', 'nonemotion_mle'); 
prior    = cell(nEmotions, 1);
transmat = cell(nEmotions, 1); 

nTotal = 0; 
for n=1:nEmotions %[p(1-emotion) p(emotion)]
    nTotal = nTotal + emotion_mle ((n*nDisplays),2); 
end
nTotal 

%calculate the priors 
for n=1:nEmotions %[(1-p(emotion)) p(emotion)]
   temp = emotion_mle((n*nDisplays),2) / nTotal;
   prior{n} = [(1-temp) temp];  
end

%calculate the observation matrices
%for n=0:nEmotions-1 %[ (1-p(Display|Nonemotion)) (1-p(Display|emotion)) p(Display|Nonemotion) p(Display|emotion)]
%    for i=1:nActive_disp
%        temp = Active_disp(i) +(n*nDisplays);
%        pd_e = emotion_mle(temp, 3); 
%        pd_ne = nonemotion_mle (temp, 3); 
%        obsmat{n+1,i}= [(1-pd_ne) (1-pd_e) pd_ne  pd_e];
%    end
%end

for n=0:nEmotions-1 %[ (1-p(Display|Nonemotion)) (1-p(Display|emotion)) p(Display|Nonemotion) p(Display|emotion)]
    nEnd= optStructSize(n+1);
    for i=1:nEnd
        temp = optStruct{n+1}(i) +(n*nDisplays);
        pd_e = emotion_mle(temp, 3); 
        pd_ne = nonemotion_mle (temp, 3); 
        obsmat{n+1,i}= [(1-pd_ne) (1-pd_e) pd_ne  pd_e];
    end
end

%calculate the transition matrices
for n=0:nEmotions-1 %[ (1-p(Emotion|Nonemotion)) (1-p(emotion|emotion)) p(Emotion|Nonemotion) p(emotion|emotion)]
    transmat{n+1}= [1.0 0.0 0.0 1.0];    
end

%Create the DBN
engine = cell(nEmotions, 1); 
for n=1:nEmotions
   for i=1:optStructSize(n)
        obs{i}= obsmat{n,i};
    end
    engine{n}= mk_complex_dbn (optStructSize(n)+1, optStructSize(n), prior{n}, obs, transmat{n}) ;   
end


save ('emotion_engines', 'prior', 'obsmat', 'transmat', 'engine'); 