function test_emotion(engine, disp_prior, disp_transmat, disp_obsmat, nActive_disp, Active_disp, ...
    Tt, nEmotions, nfiles, filenames, filelength, FID, Ferror, nIndex, nStartIndex, nEndIndex, data_set);

Tt=6; %length of a test case 
T=6; %no. of slices for inference 

nScanned=0; 
total=zeros(nEmotions,1);

fprintf(Ferror, 'Filename,Agreement,Disagreement,Thinking,Comprehending,Concentrating,Unsure,Interested\n'); 

for n=nStartIndex:nEndIndex   %for nEnd - nStart files 
    nCount = 0;
    %get data from the file
    if (eq(data_set(1,n),1)) %file is designated as a test file
        nt = filelength(n);
        for i=1:nActive_disp
          s = filenames{i}(n,:);
          test = load (s);
          testdata{i}	= test(1:nt,1:Tt);
        end
        %traverse the file, calc the LL for each active display
        disp_loglik = zeros(nActive_disp, T);      
        for a=1:nt
          for i=1:nActive_disp %for eac of our observations 
            x=Active_disp(i); 
            disp_loglik(i, a) = dhmm_logprob(testdata{i}(a,:), disp_prior{x}, disp_transmat{x}, disp_obsmat{x});
          end
        end
        %accumulate evidence, enter into all emotion engines.   
        ll = zeros(nEmotions,1); 
        marg=cell(nEmotions,nt);
        tooshort=0; 
        for a=0:nt-T-1
            for t=1:T %we have to store a running sequence of evidence of lentgh T
                for i=1:nActive_disp %for eac of our observations 
                        if (disp_loglik(i, a+t)>-7)
                       evidence{i+1,t}=2; %observation = true
                       else
                       evidence{i+1,t}=1; %observation = false
               end  
             end
            %t
        end
        %enter evidence, cal marg
        for e=1:nEmotions            
            [engine{e}, loglik] = enter_evidence(engine{e}, evidence);
            marg{e,a+1} = marginal_nodes(engine{e}, 1, T);
            ll(e) = ll(e)+ marg{e,a+1}.T(2); 
        end
        nCount=nCount+1; 
    end
    nCount
    for e=1:nEmotions
        if (nCount >0)
            error_ll(e)=((1*nCount)- ll(e)) / nCount; 
            tooshort=0; 
        else
            tooshort=1; 
            error_ll(e)=0;
        end
    end
    
    %writing the eval amd error results. 
   
    fprintf(Ferror, '%s,', filenames{1}(n,:)); 
    for e=1:nEmotions
       fprintf(FID, '%s,', filenames{1}(n,:)); 
       printEmotion(FID, e); 
       if (eq(tooshort,0))
            for a=1:nCount
                fprintf(FID, '%6.2f,',marg{e,a}.T(2));
           end
       else
           fprintf(FID, '%6.2f,',0);
       end
       fprintf(FID,'\n');
       fprintf(Ferror, '%6.2f,', error_ll(e));
   end
   fprintf(Ferror,'\n'); 
           
   if (eq(tooshort,0))
      nScanned=nScanned+1; 
      for e=1:nEmotions
          total(e)=total(e)+error_ll(e); 
      end
   end 
end
end

%When all the files are done 
fprintf(Ferror, 'Total,'); 
for e=1:nEmotions
    fprintf(Ferror, '%6.2f,', total(e));
end
fprintf(Ferror,'\n'); 
 
fprintf(Ferror, 'Scanned,'); 
for e=1:nEmotions
    fprintf(Ferror, '%6.2f,', nScanned);
end
fprintf(Ferror,'\n'); 

fprintf(Ferror, 'Normalized,'); 
for e=1:nEmotions
    fprintf(Ferror, '%6.2f,', total(e)/nScanned);
end
fprintf(Ferror,'\n'); 

fclose(FID);
fclose(Ferror);